#include <bits/stdc++.h>
using namespace std;

const int MAXN = 501;
const long long NEKONECNO = 1LL << 62;
const map<string,int> TYP_VLAKU = { {"Os",0}, {"R",1}, {"Ex",2} };

struct stav { 
    long long min_doteraz; 
    int posledny_prichod;
    int pocet_cakajucich[3];
    long long sucet_prichodov[3];
    stav() { min_doteraz = NEKONECNO; }
};

stav best[MAXN+1][MAXN+1], new_best[MAXN+1][MAXN+1];

int main() {
    int N;
    vector<int> T(3);
    cin >> N >> T[0] >> T[1] >> T[2];
    
    vector<int> casy_odchodu(N+1); // casy_odchodu[0] je zarazka: fiktivny cas odchodu pred startom kedy vsetko odislo
    
    best[0][0].min_doteraz = best[0][0].posledny_prichod = 0;

    // postupne spracuvame vlaky
    for (int n=1; n<=N; ++n) {
        string styp;
        cin >> casy_odchodu[n] >> styp;
        int typ = TYP_VLAKU.at(styp);
        
        for (int last0=0; last0<=n; ++last0) for (int last1=last0; last1<=n; ++last1) new_best[last0][last1].min_doteraz = NEKONECNO;

        // postupne prechadzame cez vsetky dosiahnutelne stavy, kazdemu pridame aktualny vlak
        int pc[3], idx[3];
        long long sp[3];
        for (int last0=0; last0<n; ++last0) for (int last1=last0; last1<n; ++last1) {
            stav teraz = best[last0][last1];
            if (teraz.min_doteraz == NEKONECNO) continue; // nedosiahnutelny stav
            
            for (int t=0; t<3; ++t) { pc[t] = teraz.pocet_cakajucich[t]; sp[t] = teraz.sucet_prichodov[t]; }
            pc[typ] += 1;
            sp[typ] += casy_odchodu[n] + T[typ];
            
            // vyskusame vsetky tri moznosti, ze ako vela toho vypravit
            long long nove_meskanie = teraz.min_doteraz;
            int novy_prichod = teraz.posledny_prichod;
            idx[0] = last0; idx[1] = last1;

            for (int t=2; t>=0; --t) {
                novy_prichod = max( novy_prichod, casy_odchodu[n]+T[t] );
                nove_meskanie += 1LL * pc[t] * novy_prichod - sp[t];
                idx[t] = n;
                pc[t] = 0;
                sp[t] = 0;
                stav &novy = new_best[idx[0]][idx[1]];
                novy.min_doteraz = min( novy.min_doteraz, nove_meskanie );
                novy.posledny_prichod = novy_prichod;
                for (int t=0; t<3; ++t) { novy.pocet_cakajucich[t] = pc[t]; novy.sucet_prichodov[t] = sp[t]; }
            }
        }
        for (int last0=0; last0<=n; ++last0) for (int last1=last0; last1<=n; ++last1) best[last0][last1] = new_best[last0][last1];
    }

    long long odpoved = NEKONECNO;
    for (int last0=0; last0<=N; ++last0) for (int last1=last0; last1<=N; ++last1) {
        stav teraz = best[last0][last1];
        if (accumulate(teraz.pocet_cakajucich, teraz.pocet_cakajucich+3, 0) == 0) odpoved = min( odpoved, teraz.min_doteraz );
    }
    cout << odpoved << endl;
}
